<!DOCTYPE html>
<html lang="en">

<head>

    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Load all orders - Danh sách đơn hàng</title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
</head>

<body onload="onPageLoading()">
    <div class="container-fluid pt-4">
        <h2 class="text-center pb-3">Danh sách đơn hàng</h2>
        <button onclick="onBtnThemDonHangClick()" class="btn btn-success">Thêm đơn hàng</button>
        <table class="table text-center table-striped" id="table-order">
            <thead>
                <tr>
                    <th scope="col">Order Code</th>
                    <th scope="col">Kích cỡ combo</th>
                    <th scope="col">Loại pizza</th>
                    <th scope="col">Nước uống</th>
                    <th scope="col">Thành tiền</th>
                    <th scope="col">Họ và tên</th>
                    <th scope="col">Số điện thoại</th>
                    <th scope="col">Trạng thái</th>
                    <th scope="col">Chi tiết</th>
                </tr>
            </thead>
            <tbody id="tbody">

            </tbody>
        </table>
    </div>

    <script>
        "use strict";
        /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
        const gREQUEST_DELETE_SUCCESS = 204
        const gREQUEST_STATUS_OK = 200;
        const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
        const gEND_OF_TABLE = -1
        const gORDER_CODE_COL = 0
        const gORDER_SIZE_COL = 1
        const gORDER_TYPE_COL = 2
        const gORDER_DRINK_COL = 3
        const gORDER_PRICE_COL = 4
        const gORDER_NAME_COL = 5
        const gORDER_PHONE_COL = 6
        const gORDER_STATUS_COL = 7
        const gORDER_INFO_COL = 8
        const gORDER_DETAIL = "orderDetail.html"
        /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */


        /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
        // Hàm thực hiện khi load trang
        function onPageLoading() {
            getAllOrders();
        }
        //Hàm xử lý sự kiện click nút chi tiết
        function onBtnChiTietClick(paramElement) {
            var vId = paramElement.dataset.id
            var vOrderCode = paramElement.dataset.ordercode
            var vUrlSiteToOpen = gORDER_DETAIL +
                "?id=" + vId +
                "&ordercode=" + vOrderCode

            window.location.href = vUrlSiteToOpen;

        }
        //Hàm xử lý sự kiện click nút Delete
        function onBtnDeleteClick(paramElement) {
            var vOrder = {
                id:""
            }
            // B1 Thu thập dữ liệu
            vOrder.id = paramElement.dataset.id
            // B2 Kiểm tra dữ liệu
            if (confirm("Bạn có muốn xóa order này không ?")) {
                // B3 Gọi Api để xóa order
                var xhr = new XMLHttpRequest()
                callApiToDeleteOrder(vOrder,xhr)
                xhr.onreadystatechange=
                function(){
                    if(this.readyState==gREQUEST_READY_STATUS_FINISH_AND_OK&&this.status==gREQUEST_DELETE_SUCCESS){
                        // B4 Xử lý hiển thị
                        console.log("Response Text là: "+xhr.responseText)
                        alert("Đã hủy order")
                        //  
                    }
                }
            }}
            // Hàm xử lý sự kiện nút thêm đơn hàng
            function onBtnThemDonHangClick(){
                var vOrder={
                    kichCo:"",
                    duongKinh:"",
                    suon:"",
                    salad:"",
                    loaiPizza:"",
                    idVourcher:"",
                    idLoaiNuocUong:"",
                    soLuongNuoc:"",
                    hoTen:"",
                    thanhTien:"",
                    email:"",
                    soDienThoai:"",
                    diaChi:"",
                    loiNhan:"",

                }
                window.location.href="create.order.html"
            }
        /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
        // Hàm thực hiện việc load all orders từ server và load vào table
        function getAllOrders() {
            /**
           * Chia để trị - 04 bước cố gắng thành 04 functions riêng biệt
           */
            // B1: Thu thập dữ liệu (trong bài này bước này ko cần)
            // B2: Validate dữ liệu (trong bài này bước này ko cần)
            // B3: Thực hiện việc gọi API từ server Server
            var vXmlHttpGetAllOrders = new XMLHttpRequest();
            callApiToGetAllOrders(vXmlHttpGetAllOrders);

            // B4: Xử lý trên front-end khi request xử lý xong và trả về response thành công
            vXmlHttpGetAllOrders.onreadystatechange = function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {

                    loadOrderToTable(vXmlHttpGetAllOrders);
                }
            }
        }
        
        // hàm gọi api để lấy all orders
        function callApiToGetAllOrders(paramXMLHttpGetAllOrders) {
            const vBaseUrl = "http://203.171.20.210:8080/devcamp-pizza365/orders";
            paramXMLHttpGetAllOrders.open("GET", vBaseUrl, true);
            paramXMLHttpGetAllOrders.send();
        }

        // input: xml http request đã đươc trả lời
        // ouptut/end: dữ liệu hiên thi trên bảng
        function loadOrderToTable(paramXMLHttpAllOrder) {
            //CODE Ở ĐÂY ĐỂ LOAD DATA VÀO TABLE

            console.log(JSON.parse(paramXMLHttpAllOrder.responseText))
            var vObjectResponse = JSON.parse(paramXMLHttpAllOrder.responseText)
            var vTableBody = document.getElementById("tbody")
            vTableBody.innerHTML = ""
            for (var bI = 0; bI < paramXMLHttpAllOrder.responseText.length; bI++) {
                // Thêm 1 dòng mỗi lần quét đến các đối tượng
                var bNewRow = vTableBody.insertRow(gEND_OF_TABLE)
                // Thêm các cột vào table
                var bCodeCell = bNewRow.insertCell(gORDER_CODE_COL)
                var bSizeCell = bNewRow.insertCell(gORDER_SIZE_COL)
                var bTypeCell = bNewRow.insertCell(gORDER_TYPE_COL)
                var bDrinkCell = bNewRow.insertCell(gORDER_DRINK_COL)
                var bPriceCell = bNewRow.insertCell(gORDER_PRICE_COL)
                var bNameCell = bNewRow.insertCell(gORDER_NAME_COL)
                var bPhoneCell = bNewRow.insertCell(gORDER_PHONE_COL)
                var bStatusCell = bNewRow.insertCell(gORDER_STATUS_COL)
                var bInfoCell = bNewRow.insertCell(gORDER_INFO_COL)
                // Điền dữ liệu vào từng ô
                bCodeCell.innerHTML = vObjectResponse[bI]?.orderCode
                bSizeCell.innerHTML = vObjectResponse[bI]?.kichCo
                bTypeCell.innerHTML = vObjectResponse[bI]?.loaiPizza
                bDrinkCell.innerHTML = vObjectResponse[bI]?.idLoaiNuocUong
                bPriceCell.innerHTML = vObjectResponse[bI]?.thanhTien
                bNameCell.innerHTML = vObjectResponse[bI]?.hoTen
                bPhoneCell.innerHTML = vObjectResponse[bI]?.soDienThoai
                bStatusCell.innerHTML = vObjectResponse[bI]?.trangThai
                // Thêm nút Chi tiết và thêm dataset, sự kiện onclick
                bInfoCell.innerHTML = `<button class="btn btn-primary"data-id=${vObjectResponse[bI]?.id}
                     data-ordercode = ${vObjectResponse[bI]?.orderCode} onclick="onBtnChiTietClick(this)">Chi Tiet</button>`
                bInfoCell.innerHTML += `<button class="btn btn-danger"data-id=${vObjectResponse[bI]?.id}
                     data-ordercode = ${vObjectResponse[bI]?.orderCode} onclick="onBtnDeleteClick(this)">Delete</button>`
            }
        }
        
        
        function callApiToDeleteOrder(paramObject,paramXMLHttp) {
            const vBaseUrl = "http://203.171.20.210:8080/devcamp-pizza365/orders";
            paramXMLHttp.open("DELETE", vBaseUrl +"/"+paramObject.id, true);
            paramXMLHttp.send();
        }
    </script>
</body>

</html>